package com.xhkjedu.sapi.service.system;

import com.xhkjedu.sapi.mapper.cloud.CloudMapper;
import com.xhkjedu.sapi.mapper.system.SchoolMapper;
import com.xhkjedu.sapi.mapper.system.SchoolStypeMapper;
import com.xhkjedu.sapi.model.cloud.TCloud;
import com.xhkjedu.sapi.model.system.TSchool;
import com.xhkjedu.sapi.model.system.TSchoolStype;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.vo.ResultVo;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author ywx
 * @classname TSchoolStypeService
 * @description
 * @date 2021/2/23 9:51
 **/
@Service
public class SchoolStypeService {
    @Resource
    private SchoolStypeMapper schoolStypeMapper;
    @Resource
    private SchoolMapper schoolMapper;
    @Resource
    private CloudMapper cloudMapper;

    //添加
    public ResultVo batchSave(List<TSchoolStype> list) {
        TSchoolStype stype = list.get(0);
        Integer schoolid = stype.getSchoolid();
        String schooldomain = stype.getSchooldomain();
        N_Utils.validation(new Object[]{schoolid, "学校id", 1});
        TSchool school = new TSchool();
        school.setSchoolid(schoolid);
        if (schooldomain == null) schooldomain = "";
        school.setSchooldomain(schooldomain);
        schoolMapper.updateByPrimaryKeySelective(school);
        list.forEach(model -> {
            model.setCreatetime(N_Utils.getSecondTimestamp());
        });
        schoolStypeMapper.batchSave(list);
        return new ResultVo(0, "保存成功");
    }

    //获取列表
    public List <TSchoolStype> listAll(TSchoolStype stype) {
        List<TSchoolStype> list = schoolStypeMapper.findAll(stype);
        if (list == null) {
            list = new ArrayList<>();
        }
        TCloud cloud = cloudMapper.getCloud();
        String schooldomain = stype.getSchooldomain();
        //登录页面字体图片
        int size = list.stream().filter(t -> t.getSchooltype().equals("loginname")).collect(Collectors.toList()).size();
        if (size == 0) {
            TSchoolStype type = new TSchoolStype();
            type.setSchooldomain(schooldomain);
            type.setSchooltype("loginname");
            type.setStypeaddr(cloud.getLoginname());
            list.add(type);
        }

        //登录背景图片
        size = list.stream().filter(t -> t.getSchooltype().equals("loginbg")).collect(Collectors.toList()).size();
        if (size == 0) {
            TSchoolStype type = new TSchoolStype();
            type.setSchooldomain(schooldomain);
            type.setSchooltype("loginbg");
            type.setStypeaddr(cloud.getLoginbg());
            list.add(type);
        }

        //技术支持
        size = list.stream().filter(t -> t.getSchooltype().equals("tesupport")).collect(Collectors.toList()).size();
        if (size == 0) {
            TSchoolStype type = new TSchoolStype();
            type.setSchooldomain(schooldomain);
            type.setSchooltype("tesupport");
            type.setStypeaddr(cloud.getTesupport());
            list.add(type);
        }

        //备案号
        size = list.stream().filter(t -> t.getSchooltype().equals("recordno")).collect(Collectors.toList()).size();
        if (size == 0) {
            TSchoolStype type = new TSchoolStype();
            type.setSchooldomain(schooldomain);
            type.setSchooltype("recordno");
            type.setStypeaddr(cloud.getRecordno());
            list.add(type);
        }
        return list;
    }

    //添加
    public ResultVo batchSave2(List<TSchoolStype> list) {
        TSchoolStype stype = list.get(0);
        Integer schoolid = stype.getSchoolid();
        N_Utils.validation(new Object[]{schoolid,"学校id",1});
        list.forEach(model->{model.setCreatetime(N_Utils.getSecondTimestamp());});
        schoolStypeMapper.batchSave(list);
        return new ResultVo(0, "保存成功");
    }

    //根据学校id获取列表
    public List <TSchoolStype> listAll2(TSchoolStype stype) {
        return schoolStypeMapper.findAll2(stype);
    }
}
