package com.xhkjedu.sexam.controller.paperstudent;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.xhkjedu.sexam.model.paperstudent.EPaperStudent;
import com.xhkjedu.sexam.service.paperstudent.EPaperStudentService;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.utils.PageUtil;
import com.xhkjedu.vo.PageResult;
import com.xhkjedu.vo.ResultVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @Description 学生考试
 * @Author WN
 * Date 2022/7/26 13:34
 **/
@RestController
@RequestMapping("/eps")
public class EPaperStudentController {
    @Resource
    private EPaperStudentService ePaperStudentService;

    //学生考试列表
    @PostMapping("/list")
    public ResultVo listExamPapersForStudent(@RequestBody EPaperStudent eps){
        N_Utils.validation(new Object[]{eps.getStudentid(),"学生id",1});
        if(eps.getSstate() == 1){
           //进行中
            List<Map> rtnlst = ePaperStudentService.listExamPapersForStudent(eps);
            return new ResultVo(0,"成功获取考试列表",rtnlst);
        }else{
            Integer page = eps.getPage();
            Integer pageSize = eps.getPageSize();
            N_Utils.validation(new Object[]{page,"显示页码",1,pageSize,"显示条数",1});
            PageHelper.startPage(page, pageSize);
            List<Map> rtnlst = ePaperStudentService.listExamsEndForStudent(eps);
            PageResult pageResult = PageUtil.getPageResult(new PageInfo<>(rtnlst));
            return new ResultVo(0,"成功获取考试列表",pageResult);
        }
    }


}
