package com.xhkjedu.sexam.model.paper;

import com.xhkjedu.sexam.model.BaseBean;
import com.xhkjedu.sexam.vo.paper.EPaperScantronParams;
import lombok.Data;

import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

@Table(name = "e_paper")
@Data
public class EPaper extends BaseBean {
    @Id
    //考试试卷表
    private Integer epid;

    //考试id
    private Integer examid;

    //考试科目表id
    private Integer esid;

    //科目id
    private String subjectid;

    //试卷类型1题库
    private Integer ptype;

    //试题数量
    private Integer pnum;

    //试卷总分
    private Double pscore;

    //是否设置正确答案0未设置1已设置
    private Integer answered;

    //批阅设置：1按班设置2按题设置
    private Integer correcttype;

    //听力题文件地址(附件试卷）
    private String hearfile;

    //是否有附件0没有1有附件
    private Integer hasfile;

    //答题卡文件
    private String scantronfile;

    //答题卡注意事项
    private String scantronnote;

    //答题卡区域宽高[200,300]
    private String scantronwh;

    //创建人
    private Integer createid;

    //创建时间
    private Integer createtime;

    //修改人
    private Integer handleid;

    //修改时间
    private Integer handletime;

    @Transient
    private List<EPaperFile> pfiles;//附件

    @Transient
    private Integer pstate;//状态0保存1提交

    @Transient
    private List<EPaperQtype> qtypelist;//题库试卷内容

    @Transient
    private List<EPaperQtypeQuestion> questions;//试题

    @Transient
    private List<EPaperScantronParams> scanlist;//答题卡内容
}