package com.xhkjedu.sexam.service.paper;

import com.xhkjedu.sexam.mapper.paper.EPaperCorrectquestionMapper;
import com.xhkjedu.sexam.mapper.paper.EPaperMapper;
import com.xhkjedu.sexam.model.paper.EPaperCorrectquestion;
import com.xhkjedu.utils.N_Utils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class EPaperCorrectquestionService {
    @Resource
    private EPaperCorrectquestionMapper ePaperCorrectquestionMapper;
    @Resource
    private EPaperMapper ePaperMapper;

    //设置批阅人
    @Transactional(rollbackFor = Exception.class)
    public void setTeacher(Integer epid, Integer createid, List<EPaperCorrectquestion> teachers) {
        ePaperCorrectquestionMapper.delByEpId(epid);//删除批阅人
        int timestamp = N_Utils.getSecondTimestamp();
        teachers.forEach(t -> {
            t.setEpid(epid);
            t.setCreateid(createid);
            t.setCreatetime(timestamp);
        });
        ePaperCorrectquestionMapper.insertList(teachers);//添加批阅人
        ePaperMapper.updateCorrectType(epid, 2);//修改批阅设置
    }

    //查看批阅人
    public List<Map> listByEpId(Integer epid) {
        List<Map> users = ePaperCorrectquestionMapper.listByEpId(epid);//试卷批阅人
        Map<Object, List<Map>> collect = users.stream().collect(Collectors.groupingBy(u -> u.get("qorder"), LinkedHashMap::new, Collectors.toList()));
        List<Map> list = new ArrayList<>();//考试题号
        for (Map.Entry<Object, List<Map>> entry : collect.entrySet()) {
            List<Map> teachers = entry.getValue();
            Map t1 = teachers.get(0);
            Map q = new HashMap();
            q.put("qn", t1.get("qn"));
            q.put("qorder", t1.get("qorder"));
            q.put("teachers", teachers);
            list.add(q);
        }
        return list;
    }

    //获取主观题题号
    public List<Map> listQnByEpId(Integer epid) {
        return ePaperCorrectquestionMapper.listQnByEpId(epid);
    }

    //根据试卷id获取考试科目基本信息
    public Map getESubjectByEpId(Integer epid) {
        return ePaperMapper.getESubjectByEpId(epid);
    }
}
